1#!/bin/sh
2#
3# Copyright (c) 2004 - 2008 Kungliga Tekniska H��gskolan
4# (Royal Institute of Technology, Stockholm, Sweden). 
5# All rights reserved. 
6#
7# Redistribution and use in source and binary forms, with or without 
8# modification, are permitted provided that the following conditions 
9# are met: 
10#
11# 1. Redistributions of source code must retain the above copyright 
12#    notice, this list of conditions and the following disclaimer. 
13#
14# 2. Redistributions in binary form must reproduce the above copyright 
15#    notice, this list of conditions and the following disclaimer in the 
16#    documentation and/or other materials provided with the distribution. 
17#
18# 3. Neither the name of the Institute nor the names of its contributors 
19#    may be used to endorse or promote products derived from this software 
20#    without specific prior written permission. 
21#
22# THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
23# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
24# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
25# ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
26# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
27# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
28# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
29# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
30# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
31# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
32# SUCH DAMAGE. 
33#
34# Id: test_nist.in 21787 2007-08-02 08:50:24Z lha 
35#
36
37srcdir="@srcdir@"
38objdir="@objdir@"
39nistdir=${objdir}/PKITS_data
40nistzip=${srcdir}/data/PKITS_data.zip
41egrep="@egrep@"
42
43limit="${1:-nolimit}"
44
45stat="--statistic-file=${objdir}/statfile"
46
47hxtool="${TESTS_ENVIRONMENT} ./hxtool ${stat}"
48
49# nistzip is not distributed part of the distribution
50test -f "$nistzip" || exit 77
51
52if ${hxtool} info | grep 'rsa: hcrypto null RSA' > /dev/null ; then
53    exit 77
54fi
55if ${hxtool} info | grep 'rand: not available' > /dev/null ; then
56    exit 77
57fi
58
59#--------- Try to find unzip
60
61oldifs=$IFS
62IFS=:
63set -- $PATH
64IFS=$oldifs
65found=
66
67for p in "$@" ; do
68    test -x "$p/unzip" && { found=1 ; break; }
69done
70test "X$found" = "X" && exit 77
71
72#---------
73
74
75echo "nist tests, version 2"
76
77if [ ! -d "$nistdir" ] ; then
78    ( mkdir "$nistdir" && unzip -d "${nistdir}" "${nistzip}" ) >/dev/null || \
79	{ rm -rf "$nistdir" ; exit 1; }
80fi
81
82ec=
83name=
84description=
85while read result cert other ; do
86    if expr "$result" : "#" > /dev/null; then
87	name=${cert}
88	description="${other}"
89	continue
90    fi
91    
92    test nolimit != "${limit}" && ! expr "$name" : "$limit" > /dev/null && continue
93
94    test "$result" = "end" && break
95
96    args=
97    args="$args cert:FILE:$nistdir/certs/$cert"
98    args="$args chain:DIR:$nistdir/certs"
99    args="$args anchor:FILE:$nistdir/certs/TrustAnchorRootCertificate.crt"
100
101    for a in $nistdir/crls/*.crl; do
102	args="$args crl:FILE:$a"
103    done
104
105    cmd="${hxtool} verify $args"
106    eval ${cmd} > /dev/null
107    res=$?
108
109    case "${result},${res}" in
110    0,0) r="PASSs";;
111    0,*) r="FAILs";;
112    [123],0) r="FAILf";;
113    [123],*) r="PASSf";;
114    *) echo="unknown result ${result},${res}" ; exit 1 ;;
115    esac
116    if ${egrep} "^${name} FAIL" $srcdir/data/nist-result2 > /dev/null; then
117	if expr "$r" : "PASS" >/dev/null; then
118	    echo "${name} passed when expected not to"
119	    echo "# ${description}" > nist2-passed-${name}.tmp
120	    ec=1
121	fi
122    elif ${egrep} "^${name} EITHER" $srcdir/data/nist-result2 > /dev/null; then
123	:
124    elif expr "$r" : "FAIL.*" >/dev/null ; then
125	echo "$r ${name} ${description}"
126	echo "# ${description}" > nist2-failed-${name}.tmp
127	echo "$cmd" >> nist2-failed-${name}.tmp
128	ec=1
129    fi
130
131done < $srcdir/data/nist-data2
132
133
134echo "done!"
135
136exit $ec
137